commit 768f456c80387efb40ae35d7873d9eee548c4232
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Fri Mar 20 19:52:14 2020 +0000

        Fix segfault on bad cmdline -f (sender) argument.  Bug 2541
    
        (cherry picked from commit 5fcc791a74a6f6933b3fb03f36e9ea3553152cf7)

diff --git a/src/src/exim.c b/src/src/exim.c
index 0e839c5d4..96c020c8e 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -2554,8 +2554,10 @@ for (i = 1; i < argc; i++)
 #ifdef SUPPORT_I18N
 	allow_utf8_domains = TRUE;
 #endif
-        sender_address = parse_extract_address(argrest, &errmess,
-          &dummy_start, &dummy_end, &sender_address_domain, TRUE);
+        if (!(sender_address = parse_extract_address(argrest, &errmess,
+		  &dummy_start, &dummy_end, &sender_address_domain, TRUE)))
+          exim_fail("exim: bad -f address \"%s\": %s\n", argrest, errmess);
+
 	sender_address = string_copy_taint(sender_address, TRUE);
 #ifdef SUPPORT_I18N
 	message_smtputf8 =  string_is_utf8(sender_address);
@@ -2563,8 +2565,6 @@ for (i = 1; i < argc; i++)
 #endif
         allow_domain_literals = FALSE;
         strip_trailing_dot = FALSE;
-        if (!sender_address)
-          exim_fail("exim: bad -f address \"%s\": %s\n", argrest, errmess);
         }
       f.sender_address_forced = TRUE;
       }

